ANN 1b18x features to add;
	add additional options for customisation of divergence behaviour;

NB these customisation options listed assume USE_BASIC_SUBNET_DIVERGENCE [ie linear divergence/convergence on any given subnet, however divergence/convergence rate may vary between subnets]
	USE_BASIC_SUBNET_DIVERGENCE = divergence or convergence {ie, not both divergence and convergence}






bool allowMissingConnection 						//default = false

bool randomiseNumberOfConnectionsInNewFrontLayer			//default = false
		if false use;
	double fractionOfConnectionsInNewFrontLayer			//default 1.0
		if true use;
	double probabilityOfConnectionInNewFrontLayer			//default 1.0

double maxNumberOfRecursiveSubnets					//default = arbitrary
double probabilityOfSubnetCreation 					//default = arbitrary	//this used to be called "probabilityOfSubnetCreation"




calculateNumberOfNeuronsInNewFrontLayer() changes;

enum divergenceType	//default = USE_BASIC_SUBNET_DIVERGENCE

		long currentNumberBasicNeuronVariation;
		long currentNumberDivergenceNeurons;

		if(numberOfInputNeurons > numberOfOutputNeurons)
		{
			currentNumberBasicNeuronVariation = -long(double(numberOfInputNeurons - numberOfOutputNeurons) * (double(currentNumberOfLayers)/double(numberOfLayers-1)));
		}
		else
		{
			currentNumberBasicNeuronVariation = long(double(numberOfOutputNeurons - numberOfInputNeurons) * (double(currentNumberOfLayers)/double(numberOfLayers-1)));
		}


		if(subnetDivergenceType == USE_BASIC_SUBNET_DIVERGENCE)
		{
			//NB static Divergence Rate: assuming convergence not divergence, each hidden layer has one less neuron, numberOfNeuronsInNewFrontLayer = numberOfInputNeurons - long(double(numberOfInputNeurons - numberOfOutputNeurons) * (double(currentNumberOfLayers)/double(numberOfLayers-1)));
			numberOfNeuronsInNewFrontLayer = numberOfInputNeurons + currentNumberBasicNeuronVariation;
		}

		if(subnetDivergenceType == USE_INTERMEDIATE_SUBNET_DIVERGENCE)
		{
			if(currentNumberOfLayers < (numberOfLayers/2))
			{
					currentNumberDivergenceNeurons = (numberOfInputNeurons * meanSubnetDivergenceFactor)*currentNumberOfLayers;
			}
			else
			{
					currentNumberDivergenceNeurons = ((numberOfInputNeurons * meanSubnetDivergenceFactor)*(numberOfLayers/2)) - (numberOfInputNeurons * meanSubnetDivergenceFactor)*(currentNumberOfLayers-(numberOfLayers/2));
			}

			//NB meanSubnetDivergenceFactor is less than 1 always; Eg 0.1 or 10% more neurons than input layer per layer
			numberOfNeuronsInNewFrontLayer = numberOfInputNeurons + currentNumberDivergenceNeurons + currentNumberBasicNeuronVariation;
		}


		if(subnetDivergenceType == USE_ADVANCED_SUBNET_DIVERGENCE)
		{
			if(currentNumberOfLayers < (numberOfLayers/2))
			{
				currentNumberInputNeuronsAndDivergenceNeurons = numberOfNeuronsInCurrentLayer + numberOfNeuronsInCurrentLayer * meanSubnetDivergenceFactor * advancedDivergenceFactor(currentNumberOfLayers, numberOfLayers);
			}
			else
			{
				currentNumberInputNeuronsAndDivergenceNeurons = numberOfNeuronsInCurrentLayer + numberOfNeuronsInCurrentLayer * meanSubnetDivergenceFactor * advancedDivergenceFactor((numberOfLayers - currentNumberOfLayers), numberOfLayers);
			}

			numberOfNeuronsInNewFrontLayer = currentNumberInputNeuronsAndDivergenceNeurons + currentNumberBasicNeuronVariation;

		}




calcNumberOfLayersInSubnet() changes;


	if USE_BASIC_SUBNET_DIVERGENCE

		if(numberOfInputNeurons > numberOfOutputNeurons)
		{
			numberOfLayersInSubnet = (numberOfInputNeurons - numberOfOutputNeurons) + 1;
		}
		else
		{
			numberOfLayersInSubnet = (numberOfOutputNeurons - numberOfInputNeurons) + 1;
		}

	if USE_SUBNETDEPENDENT_SUBNET_DIVERGENCE

		//OLD; double currentSubnetDependentDivergenceFactor;
		//subnet Dependent Divergence Rate: depending upon the subnet level, there are a different number of layers, however the number of neurons on each layer is still directly proportional to the layer number
				//OLD; currentSubnetDependentDivergenceFactor = ((double)currentNumberOfRecursiveSubnets/(double)maxNumberOfRecursiveSubnets)*(1.0/(double)numberOfLayers)


		if(numberOfInputNeurons > numberOfOutputNeurons)
		{
			numberOfLayersInSubnet = (numberOfInputNeurons - numberOfOutputNeurons) * ((double)currentNumberOfRecursiveSubnets/(double)maxNumberOfRecursiveSubnets)) + 1;
		}
		else
		{
			numberOfLayersInSubnet = (numberOfOutputNeurons - numberOfInputNeurons) * ((double)currentNumberOfRecursiveSubnets/(double)maxNumberOfRecursiveSubnets)) + 1;
		}




NB after ANN testing, maxNumberOfRecursiveSubnets needs to be made dependent on (numberInputOfLayersInTopLevelNetwork - numberInputOfOutputInTopLevelNetwork)