/*******************************************************************************
 *
 * File Name: neuralNetworkBiologicalConstructs.h
 * Author: Richard Baxter
 * Project: Advanced Neural Network (ANN) - Fractal Based Neural Network
 * Project Version: 1b20b 12-Oct-07
 * Comments: NB CHECK THIS new requirement; each subnet must have at least 3 layers
 *
 *******************************************************************************/

#ifndef BIOLOGICAL_CONSTRUCTS_HEADER
#define BIOLOGICAL_CONSTRUCTS_HEADER

#define NUMBER_OF_HORIZONTAL_PIXELS_TH (1000)
#define NUMBER_OF_VERTICAL_PIXELS_TH (1000)

#define NUMBER_OF_OBJECT_RECOGNITION_HORIZONTAL_PIXELS_TH (200)
#define NUMBER_OF_OBJECT_RECOGNITION_VERTICAL_PIXELS_TH (200)

void formNeuralNetworkBiologicalConstructs();

#endif
